%define STDC_VERSION 2.9.0
%define EGCS_VERSION 1.1.2

Summary: The GNU Compiler Collection.
Name: egcs
Version: %{EGCS_VERSION}
Release: 34mdk
Copyright: GPL
Group: Development/C
Source0: ftp://egcs.cygnus.com/pub/egcs/releases/egcs-%{EGCS_VERSION}/egcs-%{EGCS_VERSION}.tar.bz2
Source1: egcs-libstdc++-compat.tar.bz2
Patch0: ftp://ftp.varesearch.com/pub/support/hjl/egcs/egcs-1.1.2-linux.patch.bz2
Patch1: egcs-1.1.2-davem.patch.bz2
Patch2: egcs-1.1.2-gcse.patch.bz2
Patch3: egcs-1.1.2-cpu.patch.bz2
Patch4: egcs-1.1.2-fixtrunc.patch.bz2
Patch5: egcs-1.1.2-expr.patch.bz2
Patch6: egcs-1.1.2-strlen.patch.bz2
Patch7: egcs-1.1.2-warn.patch.bz2
Patch8: egcs-1.1.2-integrate.patch.bz2
Patch9: egcs-1.1.2-fold.patch.bz2
Patch10: egcs-1.1.2-asm.patch.bz2
Patch11: egcs-1.1.2-addressof.patch.bz2

Buildroot: %{_tmppath}/%{name}-%{EGCS_VERSION}-root
Url: http://egcs.cygnus.com/
Requires: binutils >= 2.9.1.0.21
Requires: gcc, %{name}-cpp
Prereq: /sbin/install-info

%description
The egcs package contains the GNU Compiler Collection: cc, gcc and
egcs. You'll need this package in order to compile C/C++ code.

%package c++
Summary: C++ support for the gcc compiler.
Group: Development/C++
Requires: egcs = %{EGCS_VERSION}

%description c++
This package adds C++ support to the GNU C compiler. It includes
support for most of the current C++ specification, including templates
and exception handling. It does include the static standard C++
library and C++ header files; the library for dynamically linking
programs is available separately.

%package objc-devel
Summary: Objective C support for the gcc compiler.
Group: Development/Other
Requires: egcs-objc = %{EGCS_VERSION}
Obsoletes: egcs-libobjc

%description objc-devel
Egcs-objc-devel provides Objective C includes for the GNU C compiler (gcc).
Mainly used on systems running NeXTSTEP, Objective C is an 
object-oriented derivative of the C language.

%package objc
Summary: Objective C support for the gcc compiler.
Group: Development/Other
Requires: egcs = %{EGCS_VERSION}

%description objc
Egcs-objc provides Objective C support for the GNU C compiler (gcc).
Mainly used on systems running NeXTSTEP, Objective C is an 
object-oriented derivative of the C language.

Install egcs-objc if you are going to do Objective C development and
you would like to use the gcc compiler.  You'll also need gcc, which
is included in the egcs package.

%package g77
Summary: Fortran 77 support for the gcc compiler.
Group: Development/Other
Requires: egcs = %{EGCS_VERSION}
Prereq: /sbin/install-info

%description g77
The egcs-g77 package provides support for compiling Fortran 77
programs with the GNU gcc compiler.

You should install egcs-g77 if you are going to do Fortran development
and you would like to use the gcc compiler.  You will also need gcc,
which is included in the egcs package.

%package cpp
Summary: The GNU C-Compatible Compiler Preprocessor.
Group: Development/C
Prereq: /sbin/install-info

%description cpp
Cpp (or cccp) is the GNU C-Compatible Compiler Preprocessor.
Cpp is a macro processor which is used automatically
by the C compiler to transform your program before actual
compilation. It is called a macro processor because it allows
you to define macros, abbreviations for longer
constructs.

The C preprocessor provides four separate functionalities: the
inclusion of header files (files of declarations that can be
substituted into your program); macro expansion (you can define macros,
and the C preprocessor will replace the macros with their definitions
throughout the program); conditional compilation (using special
preprocessing directives, you can include or exclude parts of the
program according to various conditions); and line control (if you use
a program to combine or rearrange source files into an intermediate
file which is then compiled, you can use line control to inform the
compiler about where each source line originated).

You should install this package if you are a C programmer and you use
macros.

%prep
%setup -q -n %{name}-%{EGCS_VERSION}
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p0
%patch11 -p1

mkdir compat
tar xIf %{SOURCE1} -C compat
cd gcc ; autoconf ; cd ..

%build
rm -rf obj-%{_target_platform}
mkdir obj-%{_target_platform}
cd obj-%{_target_platform}
../configure  --prefix=/usr \
	--enable-shared --enable-threads \
	%{_target_platform}

PATH=$PATH:/sbin:/usr/sbin
# gperf is most likely broken on alpha and sparc 
touch  ../gcc/c-gperf.h
make MAKEINFO="makeinfo --no-split"  bootstrap-lean

%install
rm -rf $RPM_BUILD_ROOT
cd obj-%{_target_platform}
PATH=$PATH:/sbin:/usr/sbin
make install \
	prefix=$RPM_BUILD_ROOT/usr \
	mandir=$RPM_BUILD_ROOT%{_mandir}/man1 \
	MAKEINFO="makeinfo --no-split" 
FULLVER=$($RPM_BUILD_ROOT%{_bindir}/gcc --version)
FULLPATH=$(dirname $RPM_BUILD_ROOT%{_libdir}/gcc-lib/%{_target_platform}/$FULLVER/cc1)

cat >$RPM_BUILD_ROOT%{_bindir}/egcs-version <<EOF
#!/bin/sh
echo "$FULLVER"
EOF

file $RPM_BUILD_ROOT%{_bindir}/* | grep ELF | cut -d':' -f1 | xargs strip || :
strip $FULLPATH/{cc1,cc1obj,cc1plus,cpp,f771,collect2}

install -d %buildroot/%{_bindir}
cat << EOF > %buildroot/%{_bindir}/kgcc
#!/bin/sh
exec gcc -V$FULLVER "\$@"
EOF

cat << EOF > %buildroot/%{_bindir}/kg++
#!/bin/sh
exec g++ -V$FULLVER "\$@"
EOF

chmod +x %buildroot/%{_bindir}/kg*

mkdir -p $RPM_BUILD_ROOT/lib
ln -sf ../${FULLPATH##$RPM_BUILD_ROOT/}/cpp $RPM_BUILD_ROOT/lib/cpp
ln -s cpp %buildroot/${FULLPATH##$RPM_BUILD_ROOT}/cpp0

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc README* COPYING COPYING.LIB
%dir %{_libdir}/gcc-lib
%dir %{_libdir}/gcc-lib/%{_target_platform}
%dir %{_libdir}/gcc-lib/%{_target_platform}/egcs-*
%dir %{_libdir}/gcc-lib/%{_target_platform}/egcs-*/include
%{_bindir}/kgcc
%attr(755,root,root) %{_bindir}/egcs-version


%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/SYSCALLS.c.X
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/cc1
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/collect2
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/libgcc.a
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/libgcc.map
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/specs

%ifnarch alpha
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/*.o
%endif

/usr/%{_target_platform}

%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/include/README
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/include/float.h
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/include/iso646.h
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/include/limits.h
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/include/proto.h
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/include/stdarg.h
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/include/stdbool.h
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/include/stddef.h
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/include/syslimits.h
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/include/va-*.h
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/include/varargs.h
%ifarch ppc
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/include/*-asm.h
%endif

%files cpp
%defattr(-,root,root)
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/cpp*

%files c++
%defattr(-,root,root)
%{_bindir}/kg++
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/cc1plus
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/libstdc*
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/include/exception
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/include/new
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/include/typeinfo
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/include/new.h
%{_includedir}/g+*
%ifarch ppc
%{_libdir}/nof
%endif

%files objc
%defattr(-,root,root)
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/cc1obj

%files objc-devel
%defattr(-,root,root)
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/libobjc.a
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/include/objc

%files g77
%defattr(-,root,root)
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/f771
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/libg2c.a
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/include/g2c.h


%changelog
* Sun Oct 15 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 1.1.2-34mdk
- Add cpp0 link to cpp to get works kgcc when not with the kernel.

* Mon Oct  2 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 1.1.2-33mdk
- Bzip2 patch.
- Requires: egcs-cpp.
- chmod +x kg* script (silly me :p).

* Mon Oct  2 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 1.1.2-32mdk
- s|compat-egcs|kgcc|; to allow build last 2.2.18 kernel with safe
  compiler.

* Tue Jul 25 2000 Thierry Vignaud <tvignaud@mandrakesoft.com> 1.1.2-31mdk
- split out egcs-objc-devel

* Wed Jul 19 2000 Thierry Vignaud <tvignaud@mandrakesoft.com> 1.1.2-29mdk
- BM
- use new macros

* Thu Apr 27 2000 Thierry Vignaud <tvignaud@mandrakesoft.com> 1.1.2-28mdk
- rename egcs to avoid configuration collision in bad configure scripts
  (Giuseppe Ghibo). Idem for egcs++
- merge in RH patches

* Tue Apr 18 2000 Warly <warly@mandrakesoft.com> 1.1.2-27mdk
- fixe groups

* Thu Mar 30 2000 Thierry Vignaud <tvignaud@mandrakesoft.com>
- add egcs & egcs++ scripts as Lord Chmou asked

* Thu Mar 23 2000 Thierry Vignaud <tvignaud@mandrakesoft.com>
- simplify the spec by means of spechelper
- new naming convention

* Sat Nov 13 1999 Giuseppe Ghib <ghibo@linux-mandrake.com>
- build to have egcs coexisting with gcc 2.95.X.

* Wed Sep 8 1999 Jim Kingdon <http://developer.redhat.com>
- Fix egcs-1.1.2-cpu.patch so that it works if more than one option
  from a set is specified.

* Thu Sep 3 1999 David S. Miller <davem@redhat.com>
- Fixup egcs-1.1.2-expr.patch to modify c-parse.in

* Wed Sep 1 1999 Jim Kingdon <http://developer.redhat.com>
- Add egcs-1.1.2-strlen.patch (fixes compiler core dump on certain strlen
  invocations) and egcs-1.1.2-warn.patch (makes -Wpointer-arith work
  with glibc-2.1.2-7).

* Thu Aug 19 1999 Jim Kingdon <http://developer.redhat.com>
- Replace egcs-1.1.2-global.patch (which is bogus according to Richard
  Henderson) with egcs-1.1.2-fixtrunc.patch (which fixes the same bug,
  and looks more likely to be right).

* Thu Aug 12 1999 Cristian Gafton <gafton@redhat.com>
- build a dummy libstsdc++.so.2.9 library to maintain compatibility with
  other distribution not using HJ's Linux patches.

* Tue Jul 30 1999 Jim Kingdon <http://developer.redhat.com>
- Add egcs-1.1.2-expr.patch to fix 3971 in bugzilla.

* Tue Jul 20 1999 Jim Kingdon <http://developer.redhat.com>
- Add egcs-1.1.2-global.patch, fixes core dumps.

* Mon Jul 12 1999 Cristian Gafton <gafton@redhat.com>
- improved CPU handling patch

* Thu Jun 24 1999 Cristian Gafton <gafton@redhat.com>
- added patch from rth to stop cpp from defining __i486__ macros on -m486
  (it is not supposed to according to the info page, and this makes code
  compiled with -m486 not run on i386 anymore)

* Mon May 17 1999 Matt Wilson <msw@redhat.com>
- added patch from Dave Miller

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 12)

* Wed Mar 17 1999 Cristian Gafton <gafton@redhat.com>
- version 1.1.2
- added patch from davem

* Fri Mar 12 1999 Cristian Gafton <gafton@redhat.com>
- version 1.1.2pre3
